unit fBALocalDiagnoses;

{.$define debug}

interface

uses
 Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fAutoSz, StdCtrls, ORCtrls, ExtCtrls,fPCELex, uConsults, ORFn,
  rPCE,DBCtrls, DB, DBClient, uPCE, fEncounterFrame, ComCtrls, Grids, UBAGlobals,
  Menus;

type
  DxRecord = Record
         DxFiller1  : string;
         DxFiller2  : string;
         DxAddToPL  : string;
         DxPrimary  : string;
         DxCode     : string;
     end;
  TfrmBALocalDiagnoses = class(TfrmAutoSz)
    lblPatientName: TLabel;
    Label3: TLabel;
    Panel1: TPanel;
    ORAutoPanel2: TORAutoPanel;
    lbSections: TORListBox;
    lbDiagnosis: TORListBox;
    ORAutoPanel1: TORAutoPanel;
    Label4: TLabel;
    Label5: TLabel;
    lvDxGrid: TListView;
    cbAddToPL: TCheckBox;
    btnPrimary: TButton;
    btnRemove: TButton;
    btnOther: TButton;
    Splitter1: TSplitter;
    Label2: TLabel;
    Label1: TLabel;
    lblProvDiag: TLabel;
    btnSelectAll: TButton;
    buOK: TButton;
    buCancel: TButton;
    popAddToPrsnlDxList: TPopupMenu;
    AddToPersonalDxList1: TMenuItem;
    procedure buOKClick(Sender: TObject);
    procedure buCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure lbSectionsClick(Sender: TObject);
    procedure btnOtherClick(Sender: TObject);
    procedure btnPrimaryClick(Sender: TObject);
    procedure btnRemoveClick(Sender: TObject);
    procedure btnSelectAllClick(Sender: TObject);
    procedure lvDxGridClick(Sender: TObject);
    procedure cbAddToPLClick(Sender: TObject);
    procedure ProcessAddToPLItems;
    procedure lbDiagnosisClick(Sender: TObject);
    procedure lvDxGridInsert(Sender: TObject; Item: TListItem);
    procedure FormActivate(Sender: TObject);
    procedure lbSectionsEnter(Sender: TObject);
    procedure lbDiagnosisEnter(Sender: TObject);
    procedure FormShow(Sender: TObject);

  private
    { Private declarations }
    procedure MainDriver;
    procedure LoadEncounterForm;
    procedure AddProbsToDiagnosis;
    procedure AddPCEToDiagnosis;//  adds dx's if selected currently from ecf
    procedure ListDiagnosisSections(Dest: TStrings);
    procedure ListDiagnosisCodes(Section : String);
    procedure DiagnosisSelection(SelectedDx: String);
    procedure EnsurePrimary;
    function  IsDxAlreadySelected(SelectedDx: string):boolean;
    procedure BuildTempDxList;
    procedure AssocDxToOrders;
    //function AssocDxToOrders : UBAGlobals.TBADxRecord;
    procedure ListGlobalDx;
    procedure UpdateControls;
    procedure DeselectGridItems;

  public
     procedure Enter(theCaller: smallint);
     procedure RefreshDxGrid;
     procedure LoadTempRec(var thisRec: TBADxRecord; thisOrderID: string);
  end;
   
var
  frmBALocalDiagnoses: TfrmBALocalDiagnoses;
  FDxCode: string;
  FDxSection: string;
  PList: TextFile;
  FName: string;
  MaxDx : Integer;
  GridItems: integer;
  UpdatingGrid: boolean;
  whoCalled: smallint;

implementation

uses rCore, uCore, rODMeds, rODBase, rOrders, fRptBox, fODMedOIFA,
  uAccessibleStringGrid,ORNet, fProbs, fOrdersSign, UBAConst,
  UBAMessages, fReview;

var
  uProblems    : TStringList;
  BADiagnosis  : TStringList;
  ECFDiagnosis : TStringList;
  uLastDFN     : string;
  uLastLocation: integer;
  ListItem     : TListItem;

{$R *.dfm}
//*************  Entry point *****************//

procedure TfrmBALocalDiagnoses.Enter(theCaller:smallint);
begin
   fBALocalDiagnoses.whoCalled := theCaller;
   fBALocalDiagnoses.frmBALocalDiagnoses := TfrmBALocalDiagnoses.Create(Application);
   ResizeFormToFont(TForm(frmBALocalDiagnoses));
   fBALocalDiagnoses.frmBALocalDiagnoses.ShowModal;
  //if Assigned(frmBALocalDiagnoses) then
  frmBALocalDiagnoses.Free;
end;
procedure TfrmBALocalDiagnoses.FormCreate(Sender: TObject);
begin
     MaxDx := 4;
     MainDriver;
     GridItems := 0;
end;

procedure TfrmBALocalDiagnoses.ListDiagnosisSections(Dest: TStrings);
{ return section names in format: ListIndex^SectionName (sections begin with '^') }
var
  i: Integer;
  x: string;
begin
  for i := 0 to BADiagnosis.Count - 1 do if CharAt(BADiagnosis[i], 1) = U then
  begin
    x := Piece(BADiagnosis[i], U, 2);
    if Length(x) = 0 then x := '<No Section Name>';
    Dest.Add(IntToStr(i) + U + Piece(BADiagnosis[i], U, 2) + U + x);
  end;
end;

procedure TfrmBALocalDiagnoses.MainDriver;
begin
    BADiagnosis := TStringList.Create;
    ECFDiagnosis := TStringList.Create;
    uProblems := TStringList.Create;
    lblPatientName.Caption := Patient.Name;

    UpdateControls;
    ListGlobalDx;
    LoadEncounterForm;
    ListDiagnosisSections(lbSections.Items);
end;

procedure TfrmBALocalDiagnoses.LoadTempRec(var thisRec: TBADxRecord; thisOrderID: string);
begin
  thisRec := TBADxRecord.Create;
  UBAGlobals.InitializeNewDxRec(thisRec);
  //Load it
  thisRec.FOrderID := thisOrderID;
  thisRec.FBADxCode := UBAGlobals.Dx1;
  thisRec.FBASecDx1 := UBAGlobals.Dx2;
  thisRec.FBASecDx2 := UBAGlobals.Dx3;
  thisRec.FBASecDx3 := UBAGlobals.Dx4;
end;

procedure TfrmBALocalDiagnoses.AssocDxToOrders;
//function TfrmBALocalDiagnoses.AssocDxToOrders : TBADxRecord;
var
  i: integer;
  thisOrderID: string;
  tempDxRec: TBADxRecord;
  {$ifdef debug}thismsg: string;{$endif}
begin
   //Initialize
  if Assigned(UBAGlobals.OrderIDList) then
     UBAGlobals.OrderIDList.Clear;

  //Associate Dx's to Orders
if whoCalled = F_ORDERS_SIGN then
begin
     for i := 0 to fOrdersSign.frmSignOrders.clstOrders.Items.Count-1 do
        begin
           if (frmSignOrders.clstOrders.Selected[i]) then
              begin
                 thisOrderID := TOrder(fOrdersSign.frmSignOrders.clstOrders.Items.Objects[i]).ID;

                 LoadTempRec(tempDxRec, thisOrderID);

              if ((UBAGlobals.tempDxList <> nil) and (not UBAGlobals.tempDxNodeExists(thisOrderID))) then
                  UBAGlobals.tempDxList.Add(TBADxRecord(tempDxRec))
              else
                 begin
                 BuildTempDxList;
                 // Order already exists in Dx list, so modifiy existing Dx record
                 SetBADxListForOrder(tempDxRec, thisOrderID);
                 end;

                  //Add it to OrderID string list
                  if Assigned(UBAGlobals.OrderIDList) then
                       UBAGlobals.OrderIDList.Add(thisOrderID);
              end; //if
        end; //for
end
else
   if whoCalled = F_REVIEW then
      begin
           for i := 0 to fReview.frmReview.lstReview.Items.Count-1 do
              begin
                 if (frmReview.lstReview.Selected[i]) then
                    begin
                    //thisOrderID := Copy(TOrder(fOrdersSign.frmSignOrders.clstOrders.Items.Objects[i]).ID, 0, 8);
                       thisOrderID := TOrder(fReview.frmReview.lstReview.Items.Objects[i]).ID;

                       LoadTempRec(tempDxRec, thisOrderID);
                    if ((UBAGlobals.tempDxList <> nil) and (not UBAGlobals.tempDxNodeExists(thisOrderID))) then
                            UBAGlobals.tempDxList.Add(TBADxRecord(tempDxRec))
                    else
                       begin
                       BuildTempDxList;
                       // Order already exists in Dx list, so modifiy existing Dx record
                       SetBADxListForOrder(tempDxRec, thisOrderID);
                       end;

                      //Add it to OrderID string list
                      if Assigned(UBAGlobals.OrderIDList) then
                           UBAGlobals.OrderIDList.Add(thisOrderID);
                 end;
            end; //for
      end;

  {$ifdef debug}
  with UBAGlobals.OrderIDList do
     for i := 0 to UBAGlobals.OrderIDList.Count -1 do
        begin
        thismsg := inttostr(i)+':'+#32#32 + UBAGlobals.OrderIDList.Strings[i] + #13;
        showmessage(thismsg);
        end;
  {$endif}
end;

procedure TfrmBALocalDiagnoses.buOKClick(Sender: TObject);
begin
  inherited;
//*** Load selected diagnosis to Temp List*** /////
   BuildTempDxList; //Loop thru dx grid and build list of dx's
   ProcessAddToPLItems; // Items flagged with 'add' will be added to the Problem list table
   AssocDxToOrders; //  Add selected Dx to TList for display and tracking.
   frmBALocalDiagnoses.Close;
end;

procedure  TfrmBALocalDiagnoses.LoadEncounterForm;
{ load the major coding lists that are used by the encounter form for a given location }
var
  i: integer;
  uTempList: TStringList;
  EncDt: TFMDateTime;
begin
 uLastLocation := Encounter.Location;
 EncDt := Trunc(FMToday);
  //add problems to the top of diagnoses.
  uTempList := TstringList.Create;
  try
    BADiagnosis.clear;
    tCallV(uTempList,'ORWPCE DIAG',  [uLastLocation, EncDt]);
    BADiagnosis.add(utemplist.strings[0]);
    AddProbsToDiagnosis;

    if Assigned(BAPCEDiagList) then
       AddPCEToDiagnosis;

    for i := 1 to (uTempList.Count-1) do
      begin
      BADiagnosis.add(uTemplist.strings[i]);
      end;
  finally
    uTempList.free;
  end;
end;

procedure TfrmBALocalDiagnoses.AddProbsToDiagnosis;
var
  i : integer;
  EncDt: TFMDateTime;
  x : String;
begin
   //Get problem list
   EncDt := Trunc(FMToday);
   uLastDFN := Patient.DFN;
   tCallV(UProblems, 'ORWPCE ACTPROB', [Patient.DFN, EncDT]);
   if uProblems.Count > 0 then
   begin
      BADiagnosis.add('^Problem List Items');
      for i := 1 to (uProblems.count-1) do
      begin
         x :=(Piece(uProblems.Strings[i],U,3) + U +
          Piece(uProblems.Strings[i],U,2));
         if (Piece(uproblems.Strings[i],U,3) = '799.9') then continue;            // DON'T INCLUDE 799.9 CODES

      if (Piece(uproblems.Strings[i], U, 11) =  '#') then
        BADiagnosis.add(Piece(uProblems.Strings[i],U,3) + U +                   // PL code inactive
          Piece(uProblems.Strings[i],U,2) + U + '#')
      else if (Piece(uproblems.Strings[i], U, 10) =  '') then                  // no inactive date for code
        BADiagnosis.add(Piece(uProblems.Strings[i],U,3) + U +
          Piece(uProblems.Strings[i],U,2))
      else if (Trunc(StrToFloat(Piece(uProblems.Strings[i], U, 10))) > EncDT) then     // code active as of EncDt
        BADiagnosis.add(Piece(uProblems.Strings[i],U,3) + U +
          Piece(uProblems.Strings[i],U,2))
      else
        BADiagnosis.add(Piece(uProblems.Strings[i],U,3) + U +                   // PL code inactive
          Piece(uProblems.Strings[i],U,2) + U + '#');
    end;
  end;
end;

procedure TfrmBALocalDiagnoses.AddPCEToDiagnosis;
var
  i: integer;
begin
     for i := 0 to (BAPCEDiagList.Count-1) do
     begin
     if CharAt(BAPCEDiagList.Strings[i], 1) = U then
        BADiagnosis.Add(BAPCEDiagList.Strings[i])  // section header
     else
     begin
        BADiagnosis.add(Piece(BAPCEDiagList.Strings[i],U,1) + U +
                        Piece(BAPCEDiagList.Strings[i],U,2));
     end;
end;
end;

///********    Edit Dx Grid ********************//

procedure TfrmBALocalDiagnoses.buCancelClick(Sender: TObject);
begin
   Close;
end;

procedure TfrmBALocalDiagnoses.Button4Click(Sender: TObject);
begin
 Close;
end;

procedure TfrmBALocalDiagnoses.lbSectionsClick(Sender: TObject);
var i: integer;
begin
for i := 0 to lbSections.Items.Count-1 do
    if(lbSections.Selected[i]) then
    begin
       ListDiagnosisCodes(lbSections.Items[i]);
       FDXSection := lbSections.Items[i];
       lvDxGrid.SetFocus;
       Break;
    end;
end;

procedure TfrmBALocalDiagnoses.ListDiagnosisCodes(Section: String);
var
i,j: integer;
a: string;
begin
   lbDiagnosis.Clear;
   for i := 0 to BADiagnosis.Count-1 do
      begin
         a := BADiagnosis.Strings[i];
         if Piece(BADiagnosis[i], U, 2) = (Piece(Section,U,2)) then
            break;
     end;
     inc(i);
     for j := i to BADiagnosis.Count-1 do
     begin
        if Piece(BADiagnosis[j], U, 0) = '' then
           break
        else
        begin
           a :=  Piece(BADiagnosis[j], U, 2) + '^' + Piece(BADiagnosis[j], U, 1);
           lbDiagnosis.Items.Add(a);
        end;
     end;
end;

procedure TfrmBALocalDiagnoses.btnOtherClick(Sender: TObject);
var
  Match: string;
  selectedDx: string;
  i: integer;
begin
   ProvDx.Code := ''; //init
   //Execute LEXICON
   LexiconLookup(Match, LX_ICD);
  if Match = '' then Exit;
  fOrdersSign.ProvDx.Code := Piece(Match, U, 1);
  fOrdersSign.ProvDx.Text := Piece(Match, U, 2);
  i := Pos(' (ICD', fOrdersSign.ProvDx.Text);
  if i = 0 then i := Length(ProvDx.Text) + 1;
  if fOrdersSign.ProvDx.Text[i-1] = '*' then i := i - 2;
  fOrdersSign.ProvDx.Text := Copy(fOrdersSign.ProvDx.Text, 1, i - 1);
  selectedDx := (fOrdersSign.ProvDx.Text + ':' + fOrdersSign.ProvDx.Code);
  if not IsDxAlreadySelected(selectedDx) then
     DiagnosisSelection(selectedDx);

end;

procedure TfrmBALocalDiagnoses.btnPrimaryClick(Sender: TObject);

var
  i: shortint;
  Primary: boolean;
begin
  inherited;
  //Exit if list empty
  Primary := FALSE;
   if lvDxGrid.Items.Count = 0 then Exit;

    for i := 0 to lvDxGrid.Items.Count-1 do
     if(lvDxGrid.Items[i].Selected) then
     begin
       if not Primary then
       begin
          LvDxGrid.Items[i].SubItems[0] := UBAConst.PRIMARY_DX;
          Primary :=TRUE;
       end;
    end
     else
        LvDxGrid.Items[i].SubItems[0] := UBAConst.SECONDARY_DX ;
     if not Primary then EnsurePrimary;
        UpdateControls;
      lvDxGrid.Setfocus;
end;

procedure TfrmBALocalDiagnoses.btnRemoveClick(Sender: TObject);
var
  i: integer;
begin
  inherited;
  for i := 0 to lvDxGrid.Items.Count-1 do
     if(lvDxGrid.Items[i].Selected) then
     begin
       if LvDxGrid.Items[i].SubItems[0] = UBAConst.PRIMARY_DX then
       begin
          Break;
       end;
  end;
  lvDxGrid.DeleteSelected;
  DeselectGridItems;
  EnsurePrimary;
  UpdateControls;
end;

procedure TfrmBALocalDiagnoses.btnSelectAllClick(Sender: TObject);
begin
  inherited;
  lvDxGrid.MultiSelect := true;
  lvDxGrid.SelectAll;
  lvDxGrid.Setfocus;
end;

procedure TfrmBALocalDiagnoses.RefreshDxGrid;
//Read ALL populated fields of DxList.DxRec's, and display them on the grid.
begin

   //  DxRec.FBADxCode

end;

procedure TfrmBALocalDiagnoses.DiagnosisSelection(SelectedDx: String);
begin
//Set up Dx grid
 cbAddToPL.Enabled := True;
 if lvDxGrid.Items.Count < MaxDx then
 begin
   if lvDxGrid.Items.count = 0 then
   begin
      ListItem := lvDxGrid.Items.Add; //  add the row instance prior to adding text                                         //  adding text.
      ListItem.SubItems.Add(UBAConst.PRIMARY_DX);
      ListItem.SubItems.Add(SelectedDX);
 //     DeselectGridItems;
      lvDxGrid.Items[0].Selected := true;
   end
   else
      begin
         DeselectGridItems;
         ListItem := lvDxGrid.Items.Add;    //  add the row instance prior to adding text.
         ListItem.SubItems.Add(UBAConst.SECONDARY_DX);
         ListItem.SubItems.Add(SelectedDX);
         lvDxGrid.Items[lvDxGrid.Items.Count-1].Selected := true;
      end;
   end
    else
    begin
       DeselectGridItems;
       lvDxGrid.Items[MaxDx-1].Selected := True;
       ShowMessage(BA_MAX_DX);
    end;
   lvDxGrid.SetFocus;
end;

function TfrmBALocalDiagnoses.IsDxAlreadySelected(SelectedDx: string):boolean;
var i: integer;
begin
   Result := False;
   with lvDxGrid do
   begin
      for i := 0 to lvDxGrid.Items.Count-1 do
    if lvDxGrid.Items[i].Subitems[1] = SelectedDx then
       begin
          Result := True;
          Break;
       end;
    end;
end;

procedure TfrmBALocalDiagnoses.EnsurePrimary;
var
Primary: boolean;
i : integer;

begin
  Primary := False;
  for i := 0 to lvDxGrid.Items.Count-1 do
     if LvDxGrid.Items[i].SubItems[0] = UBAConst.PRIMARY_DX then
     begin
        Primary := True;
        lvDxGrid.SetFocus;
        Break;
   end;

  if not Primary then
  begin
     if lvDxGrid.Items.Count > 0 then
     begin
        lvDxGrid.Items[0].Selected := True;
        lvDxGrid.Items[0].Subitems[0] := UBAConst.PRIMARY_DX;
        lvDxGrid.SetFocus;
     end;
  end;
end;

procedure TfrmBALocalDiagnoses.lvDxGridClick(Sender: TObject);
var
    i,j: integer;
begin
  UpdatingGrid := False;
  cbAddToPL.Enabled := False;

  for i := 0 to lvDxGrid.Items.Count-1 do
     if(lvDxGrid.Items[i].Selected) and
        (lvDxGrid.Items[i].Caption = 'AddPL') then
     begin
         UpdatingGrid := True;
         lvDxGrid.Items[i].Selected := True;
 //        DeselectGridItems;
         cbaddToPL.Checked := true;
    end ;
     if Not UpdatingGrid then
        cbAddToPL.Checked := False
     else
        UpdatingGrid := false;


   for j := 0 to lvDxGrid.Items.Count-1 do
     if(lvDxGrid.Items[j].Selected) then
     begin
         cbAddToPL.Enabled := True;
         DeselectGridItems;
         lvDxGrid.Items[j].Selected := True;
         Break;
     end
     else
        EnsurePrimary;
end;

procedure TfrmBALocalDiagnoses.cbAddToPLClick(Sender: TObject);
var i: integer;
begin
  inherited;
if Not UpdatingGrid then
begin
   if cbAddToPL.Checked then
   begin
      for i := 0 to lvDxGrid.Items.Count-1 do
        if(lvDxGrid.Items[i].Selected) and
           not (lvDxGrid.Items[i].Caption = 'AddPL') then
           begin
              lvDxGrid.Items[i].Caption := 'AddPL';
              cbaddToPL.Checked := true;
              lvDxGrid.SetFocus;
         end
         else
         if(lvDxGrid.Items[i].Selected) and
           (lvDxGrid.Items[i].Caption = 'AddPL') then
         begin
            lvDxGrid.Items[i].Caption := '';
            cbaddToPL.Checked := false;
            lvDxGrid.SetFocus;
         end;
   end
   else
     begin
      if not cbaddToPL.Checked then
      for i := 0 to lvDxGrid.Items.Count-1 do
      begin
         if(lvDxGrid.Items[i].Selected) and
           (lvDxGrid.Items[i].Caption = 'AddPL') then
         begin
            lvDxGrid.Items[i].Caption := '';
         end;
      end;
   end;
end;
    EnsurePrimary;
end;

//  add items flagged to be added the Problem List
procedure TfrmBALocalDiagnoses.ProcessAddToPLItems;
var i: integer;
tempCode, passCode: string;
PLlist, NewList: TStringList;
begin
    NewList := TStringList.Create;
    PLlist := TStringList.Create;
    PLlist.Clear;
    //  Add Diagnosis to Problem List if flagged with 'Add' in First Col.
    PLlist := BAPLRec.BuildBAProblemRecHDR;
    with lvDxGrid do
    begin
       for i := 0 to Items.Count-1 do
        if LvDxGrid.Items[i].Caption = 'AddPL' then
        begin
           tempCode := lvDxGrid.Items[i].Subitems[1];
             //   passCode consists of Dx Code '^' Dx Desc /////
           passCode := Piece(tempCode,':',2) + '^'+ Piece(tempCode,':',1);
           NewList := BAPLRec.BuildBAProblemRecDTL(PLlist,'',passCode);
        end;
        if NewList.Count > 0 then
           BAPLRec.SaveProblemRec(NewList); //
  end;

  if Assigned(NewList) then NewList.Free;
end;

procedure TfrmBALocalDiagnoses.BuildTempDxList;
var i : integer;
    tempStr1,tempStr2: string;
    tempStrList: TStringList;
begin
   tempStrList := TStringList.Create;
   if Assigned(tempStrList) then tempStrList.Clear;

   UBAGlobals.Dx1 := '';
   UBAGlobals.Dx2 := '';
   UBAGlobals.Dx3 := '';
   UBAGlobals.Dx4 := '';
   tempstr1 := '';
   tempstr2 := '';
   with lvDxGrid do
    begin
       for i := 0 to Items.Count-1 do
       begin
          //   x:= lvDxGrid.Items[i].Subitems[0] + '^' + lvDxGrid.Items[i].Subitems[1];
           tempStrList.Add(lvDxGrid.Items[i].Subitems[0] + '^' + lvDxGrid.Items[i].Subitems[1]);
      end;
   end;
    if tempStrList.Count > 0 then
       tempStrList.Sort;  //  Sort list Ascending order.
    with  tempStrList do
    begin
       for i := 0 to  tempStrList.Count-1 do
       begin
           tempstr1 := (Piece(tempStrList.Strings[i],U,2));
           tempstr2 := (Piece(tempstr1,':',1) + '^'+ Piece(tempstr1,':',2));
           case i of
              0: UBAGlobals.Dx1 := tempStr2;
              1: UBAGlobals.Dx2 := tempStr2;
              2: UBAGlobals.Dx3 := tempStr2;
              3: UBAGlobals.Dx4 := tempStr2;
           else
             Exit;
           end;
       end;
    end;
   tempStrList.Free;
end;

procedure TfrmBALocalDiagnoses.ListGlobalDx;
begin
   if not Assigned(UBAGlobals.globalDxRec) then Exit;
   if (Assigned(UBAGlobals.globalDxRec)) and (UBAGlobals.globalDxRec.FBADxCode = '') then Exit;

   //Load grid with dx
   ListItem := lvDxGrid.Items.Add;
   ListItem.SubItems.Add(UBAConst.PRIMARY_DX);
   ListItem.SubItems.Add(UBAGlobals.globalDxRec.FBADxCode);

   if UBAGlobals.globalDxRec.FBASecDx1 <> '' then
     begin
     ListItem := lvDxGrid.Items.Add;
     ListItem.SubItems.Add(UBAConst.SECONDARY_DX);
     ListItem.SubItems.Add(UBAGlobals.globalDxRec.FBASecDx1);
     end;

   if UBAGlobals.globalDxRec.FBASecDx2 <> '' then
     begin
     ListItem := lvDxGrid.Items.Add;
     ListItem.SubItems.Add(UBAConst.SECONDARY_DX);
     ListItem.SubItems.Add(UBAGlobals.globalDxRec.FBASecDx2);
     end;

   if UBAGlobals.globalDxRec.FBASecDx3 <> '' then

     begin
     ListItem := lvDxGrid.Items.Add;
     ListItem.SubItems.Add(UBAConst.SECONDARY_DX);
     ListItem.SubItems.Add(UBAGlobals.globalDxRec.FBASecDx3);
     end;
end;

procedure TfrmBALocalDiagnoses.lbDiagnosisClick(Sender: TObject);
var
 i : integer;
  newDxCode: string;
begin
  inherited;
   cbAddToPL.Checked := False;

 for i := 0 to lbDiagnosis.Items.Count-1 do
     if(lbDiagnosis.Selected[i]) then
     begin
        newDxCode := (Piece(lbDiagnosis.Items[i],U,1) + ':'+ Piece(lbDiagnosis.Items[i],U,2));
        if not IsDxAlreadySelected(newDxCode) then
           DiagnosisSelection(newDxCode)
        else
           begin
              DeselectGridItems;
              lvDxGrid.Items[lvDxGrid.Items.Count-1].Selected := true;
              cbAddToPL.Enabled := True;
              lvDxGrid.SetFocus;
           end;
     end;
end;

procedure TfrmBALocalDiagnoses.UpdateControls;
begin
   if lvDxGrid.Items.Count = 0 then
   begin
      cbAddToPL.Enabled    := False;
      btnPrimary.Enabled   := False;
      btnRemove.Enabled    := False;
      btnSelectAll.Enabled := False;
   end
   else
   begin
      btnPrimary.Enabled   := True;
      btnRemove.Enabled    := True;
      btnSelectAll.Enabled := True;
   end;
end;

procedure TfrmBALocalDiagnoses.DeselectGridItems;
var
i: integer;
begin
    for i := 0 to lvDxGrid.Items.Count-1 do
    begin
       lvDxGrid.Items[i].Selected := false;
    end;
end;


procedure TfrmBALocalDiagnoses.lvDxGridInsert(Sender: TObject;
  Item: TListItem);
begin
  inherited;
   UpdateControls;
end;

procedure TfrmBALocalDiagnoses.FormActivate(Sender: TObject);
begin
  inherited;
     //KW 20030909
     lbSections.TabOrder := 0;
     lbDiagnosis.TabOrder := 1;
     btnOther.TabOrder := 2;
     ORAutoPanel1.TabStop := true;
     ORAutoPanel1.TabOrder := 3;
     lvDxGrid.TabStop := true;
     lvDxGrid.TabOrder := 4;
     cbAddToPL.TabOrder := 5;
     btnPrimary.TabOrder := 6;
     btnRemove.TabOrder := 7;
     btnSelectAll.TabOrder := 8;
     buOK.TabOrder := 9;
     buCancel.TabOrder := 10;
end;

procedure TfrmBALocalDiagnoses.lbSectionsEnter(Sender: TObject);
begin
  inherited;
  lbSections.Selected[0] := true;
end;

procedure TfrmBALocalDiagnoses.lbDiagnosisEnter(Sender: TObject);
begin
  inherited;
  if lbDiagnosis.Count > 0 then
     lbDiagnosis.Selected[0] := true;
end;

procedure TfrmBALocalDiagnoses.FormShow(Sender: TObject);
begin

   if lbSections.Count > 0 then
      ListDiagnosisCodes(lbSections.Items[0]);
   lbSections.SetFocus;
end;


end.

